#include<stdio.h>
#include<math.h>
#include <malloc.h>
#include <string.h>


typedef int (*delegate_func)(int, int);

typedef struct 
{
	delegate_func* funcs;
	int count;
} Delegate;


int summ(int a, int b) 
{
	return a + b;
}

int diff(int a, int b)
{
	return a - b;
}

void zadanie1() // 1
{
	int (*FS)(int,int);
	FS = summ;
	printf("  summ %d\n", FS(10,5));
	int(*FArr[2])(int, int);
	FArr[0] = summ;
	FArr[1] = diff;
	for (int i = 0; i < 2; i++)
	{
		printf("  %d = %d\n", i+1, FArr[i](10,3));
	}
}

void add_function_to_delegate(Delegate* d, delegate_func func) // 2
{
	d->count++;
	d->funcs = (delegate_func*)realloc(d->funcs, d->count * sizeof(delegate_func));
	d->funcs[d->count - 1] = func;
}

void invoke_delegate(Delegate* d, int a, int b) // 4
{
	for (int i = 0; i < d->count; i++)
	{
		printf("  %d: %d\n", i + 1, d->funcs[i](a, b));
	}
}

void remove_delegate(Delegate d)
{
	free(d.funcs);
	d.count = 0;
}

void removeFunction(Delegate* delegate, delegate_func func);
void zadanie2() // 2
{
	Delegate d = { .count = 0 };
	printf(" \n");
	add_function_to_delegate(&d, summ);
	add_function_to_delegate(&d, diff);
	invoke_delegate(&d, 5, 3);	
	printf(" \n");
	removeFunction(&d, summ);
	removeFunction(&d, diff);
	add_function_to_delegate(&d, diff);
	invoke_delegate(&d, 5, 3);
	
}

void removeFunction(Delegate* delegate, delegate_func func) // 3
{
	for (int i = 0; i < delegate->count; i++) 
	{
		if (delegate->funcs[i] == func)
		{
			for (int j = i; j < delegate->count - 1; j++) {
				delegate->funcs[j] = delegate->funcs[j + 1];
			}
			delegate->count--;
			delegate->funcs = (delegate_func*)realloc(delegate->funcs, delegate->count * sizeof(delegate_func));
			break;
		}
	}
}

void zadanie3()// 3
{
	Delegate d = { .count = 0 };
	printf(" \n");
	add_function_to_delegate(&d, summ);
	add_function_to_delegate(&d, diff);
	invoke_delegate(&d, 5, 3);
	printf("   diff(2)\n");
	removeFunction(&d, diff);
	invoke_delegate(&d, 5, 3);
}

void remove_duplicate_functions(Delegate* delegate) {
	for (int i = 0; i < delegate->count; i++) {
		for (int j = i + 1; j < delegate->count; j++) {
			if (delegate->funcs[i] == delegate->funcs[j]) {
				removeFunction(delegate, delegate->funcs[j]);
				j--;
			}
		}
	}
}

void zadanie4()
{
	Delegate d = { .count = 0 };
	printf(" \n");
	add_function_to_delegate(&d, summ);
	add_function_to_delegate(&d, diff);
	invoke_delegate(&d, 5, 3);
	printf("  \n");
	add_function_to_delegate(&d, diff);
	add_function_to_delegate(&d, summ);
	add_function_to_delegate(&d, diff);
	add_function_to_delegate(&d, summ);
	add_function_to_delegate(&d, summ);
	add_function_to_delegate(&d, summ);
	add_function_to_delegate(&d, summ);
	add_function_to_delegate(&d, diff);
	add_function_to_delegate(&d, summ);
	add_function_to_delegate(&d, summ);
	add_function_to_delegate(&d, diff); 
	add_function_to_delegate(&d, diff);
	add_function_to_delegate(&d, summ);
	add_function_to_delegate(&d, summ);
	add_function_to_delegate(&d, summ);
	invoke_delegate(&d, 5, 3);
	printf("   \n");
	remove_duplicate_functions(&d, diff);
	remove_duplicate_functions(&d, summ);
	invoke_delegate(&d, 5, 3);	
	remove_delegate(d);
}


int main(void)
{
	system("chcp 1251>nul");
	printf("1.             \n");
	printf("2.      \n");
	printf("3.      \n");
	printf("4.         \n");
	int n, zadanie = 0;
	while (zadanie == 0)
	{
		printf("\n   (1-4): ");
		if (scanf_s("%d", &n)!=1)
		{
			printf(" ,   \n");
			zadanie = 1;
		}
		switch (n)
		{
		case 1:
			zadanie1();
			break;
		case 2:
			zadanie2();
			break;
		case 3:
			zadanie3();
			break;
		case 4:
			zadanie4();
			break;
		default:
			printf("  ");
			break;
		}
		int c = -1;
		printf("\n\n    ? 0 - , 1 - \n");
		scanf_s("%d", &c);
		if (c == 0) zadanie = 1;
	}
	return 0;
}